package de.lmu.ifi.eibnf.kiosk;

import de.lmu.ifi.eibnf.interfaces.Buyable;
import de.lmu.ifi.eibnf.productsSchnittstellen.Bonbons;
import de.lmu.ifi.eibnf.productsSchnittstellen.Schokolade;
import de.lmu.ifi.eibnf.productsVererbung.Magazine;
import de.lmu.ifi.eibnf.productsVererbung.Obst;
import de.lmu.ifi.eibnf.productsVererbung.Product;
import de.lmu.ifi.eibnf.productsVererbung.Waschmittel;

/**
 * 
 * @author Michael Kirsch Diese Klasse repräsentiert eine Kasse, mit der Produkte abgrechnet werden
 * @Date 16.12.2014
 */
public class Kasse {

    public static void main(String[] args) {

	PriceUtils priceUtility = new PriceUtils();

	/**
	 * Hier muss ein Produkt zwingend von Product erben, damit diese Variante funktioniert
	 */

	System.out.println("Variante mit Vererbung");
	Product javaMagazine = new Magazine();
	javaMagazine.price = 3.5;

	Product perwoll = new Waschmittel();
	perwoll.price = 5;

	Product apfel = new Obst();
	apfel.price = 0.8;

	System.out.printf("%.2f", priceUtility.calculateSum(javaMagazine, perwoll, apfel));

	System.out.print("\n\n"); // Leerzeilen

	/**
	 * Hier wird nur gefordert, dass die Schnittstelle Buyable implementiert ist. Es ist somit egal, welche Vererbungshierarchie es gibt oder welcher Typ es letztlich ist.
	 */

	System.out.println("Variante mit Schnittstellen");
	Buyable milka = new Schokolade();
	Buyable nimmZwei = new Bonbons();
	System.out.printf("%.2f", priceUtility.calculateSum(milka, nimmZwei));

    }
}
